<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="站点名称" prop="siteName">
        <el-input
          v-model="queryParams.siteName"
          placeholder="请输入站点名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>


      <el-form-item label="联系人" prop="siteContractName">
        <el-input
          v-model="queryParams.siteContractName"
          placeholder="请输入联系人"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="电话" prop="siteContractPhone">
        <el-input
          v-model="queryParams.siteContractPhone"
          placeholder="请输入电话"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['inspection:info:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['inspection:info:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['inspection:info:remove']"
        >删除</el-button>
      </el-col>

      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="infoList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />

      <el-table-column label="站点名称" align="center" prop="siteName" />

      <el-table-column label="位置详细" align="center" prop="siteAddress" />
      <el-table-column label="联系人" align="center" prop="siteContractName" />
      <el-table-column label="电话" align="center" prop="siteContractPhone" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['inspection:info:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['inspection:info:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改inspection对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="站点名称" prop="siteName">
          <el-input v-model="form.siteName" placeholder="请输入站点名称" />
        </el-form-item>

        <el-form-item label="选择位置" prop="province">
          <el-button type="primary" icon="el-icon-location-outline"
                     @click="chooseLatLng('group',form.siteLatitude,form.siteLongitude)"></el-button>
        </el-form-item>
        <div class="mapPop" v-show="mapOpen" style="z-index: 999">
          <div class="title">单击位置选点，用于小程序导航使用 <span @click="mapOpen = false">X</span></div>
          <div id="map" style="width: 800px;height: 500px"></div>
        </div>
        <el-form-item label="位置详细" prop="siteAddress">
          <el-input v-model="form.siteAddress" placeholder="请输入位置详细" />
        </el-form-item>
        <el-form-item label="联系人" prop="siteContractName">
          <el-input v-model="form.siteContractName" placeholder="请输入联系人" />
        </el-form-item>
        <el-form-item label="电话" prop="siteContractPhone">
          <el-input v-model="form.siteContractPhone" placeholder="请输入电话" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
   import { listInfo, getInfo, delInfo, addInfo, updateInfo } from "../api/siteInfo";

  export default {
    name: "Info",
    data() {
      return {
        mapOpen:false,
        mapType: null,
        centerPoint: {
          latitude: 28.87094638073256,
          longitude: 105.44209957122803
        },
        shopconfigList: [],
        shopConfig: {},
        // 遮罩层
        loading: true,
        // 选中数组
        ids: [],
        // 非单个禁用
        single: true,
        // 非多个禁用
        multiple: true,
        // 显示搜索条件
        showSearch: true,
        // 总条数
        total: 0,
        // inspection表格数据
        infoList: [],
        // 弹出层标题
        title: "",
        // 是否显示弹出层
        open: false,
        // 查询参数
        queryParams: {
          pageNum: 1,
          pageSize: 10,
          siteName: null,
          siteLongitude: null,
          siteLatitude: null,
          siteAddress: null,
          siteContractName: null,
          siteContractPhone: null,
        },
        // 表单参数
        form: {},
        // 表单校验
        rules: {
        }
      };
    },
    created() {
      this.getList();
    },
    methods: {
      /** 查询inspection列表 */
      getList() {
        this.loading = true;
        listInfo(this.queryParams).then(response => {
          this.infoList = response.rows;
          this.total = response.total;
          this.loading = false;
        });
      },
      //获取地址
      mapInit(lat, lng) {
        console.log(lat, lng)
        lat = lat?lat:this.centerPoint.latitude
        lng = lng?lng:this.centerPoint.longitude
        let that = this;
        let map = new qq.maps.Map(document.getElementById("map"), {
          center: new qq.maps.LatLng(lat, lng),
          zoom: 13
        });
        let marker = new qq.maps.Marker({
          map: map,
          position: new qq.maps.LatLng(lat, lng),
        });

        //添加监听事件
        qq.maps.event.addListener(map, 'click', function (event) {
          console.log('经纬赋值',event.latLng.lat, event.latLng.lng);
          // this.queryParams.longitude = event.latLng.lat
          // this.queryParams.latitude = event.latLng.lng
          // console.log('赋值后', this.queryParams.longitude, this.queryParams.latitude);
          let marker = new qq.maps.Marker({
            map: map,
            position: new qq.maps.LatLng(event.latLng.lat, event.latLng.lng),
          });
          setTimeout(() => {
            that.setValueLatLng(event.latLng.lat, event.latLng.lng)
          }, 500)
        });
      },
      chooseLatLng(type, lat, lng) {

        this.mapOpen = true
        this.mapInit(lat, lng);
        this.mapType = type
      },
      //经纬度
      setValueLatLng(lat, lng) {
        console.log('这一步',lat, lng)
        this.form.siteLatitude=lat
        this.form.siteLongitude=lng
        // if (this.mapType == "group") {
        //   this.form.groupLongitude = lng
        //   this.form.groupLatitude = lat
        // }
        // if (this.mapType == "school") {
        //   this.form.schoolLongitude = lng
        //   this.form.schoolLatitude = lat
        // }
        this.mapOpen = false
      },

      // 取消按钮
      cancel() {
        this.open = false;
        this.reset();
      },
      // 表单重置
      reset() {
        this.form = {
          id: null,
          siteName: null,
          siteLongitude: null,
          siteLatitude: null,
          siteAddress: null,
          siteContractName: null,
          siteContractPhone: null,
          orderNum: null,
          createTime: null,
          createBy: null,
          updateTime: null,
          updateBy: null
        };
        this.resetForm("form");
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.getList();
      },
      /** 重置按钮操作 */
      resetQuery() {
        this.resetForm("queryForm");
        this.handleQuery();
      },
      // 多选框选中数据
      handleSelectionChange(selection) {
        this.ids = selection.map(item => item.id)
        this.single = selection.length!==1
        this.multiple = !selection.length
      },
      /** 新增按钮操作 */
      handleAdd() {
        this.reset();
        this.open = true;
        this.title = "添加inspection";
      },
      /** 修改按钮操作 */
      handleUpdate(row) {
        this.reset();
        const id = row.id || this.ids
        getInfo(id).then(response => {
          this.form = response.data;
          this.open = true;
          this.title = "修改inspection";
        });
      },
      /** 提交按钮 */
      submitForm() {
        this.$refs["form"].validate(valid => {
          if (valid) {
            if (this.form.id != null) {
              updateInfo(this.form).then(response => {
                this.$modal.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              });
            } else {
              addInfo(this.form).then(response => {
                this.$modal.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              });
            }
          }
        });
      },
      /** 删除按钮操作 */
      handleDelete(row) {
        const ids = row.id || this.ids;
        this.$modal.confirm('是否确认删除inspection编号为"' + ids + '"的数据项？').then(function() {
          return delInfo(ids);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        }).catch(() => {});
      },
      /** 导出按钮操作 */
      handleExport() {
        this.download('inspection/info/export', {
          ...this.queryParams
        }, `info_${new Date().getTime()}.xlsx`)
      }
    }
  };
</script>
<style>
.mapPop {
  position: fixed;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);

  #map {
    border: 2px solid #d5d5d5;
  }

  .title {
    padding: 10px;
    background-color: #00afff;
    color: #FFF;

    span {
      float: right;
    }
  }
}
.dianz{
  cursor:pointer;
  color: #1c84c6;
}
</style>
